--- /usr/src/sys/dev/ic/rtl81x9.c.orig	Fri Dec  3 09:37:01 2004
+++ /usr/src/sys/dev/ic/rtl81x9.c	Fri Dec  3 09:38:04 2004
@@ -1135,6 +1135,19 @@ int rl_ioctl(ifp, command, data)
 	case SIOCSIFMEDIA:
 		error = ifmedia_ioctl(ifp, ifr, &sc->sc_mii.mii_media, command);
 		break;
+       case SIOCSIFMACADDR:
+               if (ifr->ifr_addr.sa_family == AF_ETHER) {
+                       bcopy(ifr->ifr_addr.sa_data,
+				       sc->sc_arpcom.ac_enaddr,
+                               ETHER_ADDR_LEN);
+                       ether_ifsetaddr(ifp);
+                       rl_init(sc);
+               } else {
+                       error = EINVAL;
+               }
+               break;
+
+
 	default:
 		error = EINVAL;
 		break;
